package edu.psu.geovista.datamining.util;

/**
 * Title:        Algorithms and Modules for Spatial Data Mining
 * Description:  Implementation of dissertation ideas.
 * Copyright:    Copyright (c) 2001
 * Company:      Department of Geography, PennState University
 * @author Diansheng Guo
 * @version 1.0
 */
import java.awt.Color;

public class ColorSetting {

  /**
   * Black background color scheme
   * */
//  public static Color background = Color.black; // Color.black;
//  public static Color disabled   = Color.darkGray;
//  public static Color edgecolor  = Color.cyan; //new Color(0, 0, 255, 128); //new Color(143, 57, 191); //purple
//  public static Color pointcolor = Color.lightGray;
//  public static Color labelcolor = Color.pink; //.pink;
//  public static Color corepointcolor = Color.green;
//  public static Color neutralcolor = Color.gray;
//  public static Color selection  = Color.yellow;
//
//  public static Color PCP_AXIS_COLOR = Color.gray;
//  public static Color PCP_AXIX_VALUE_COLOR = Color.orange;
//  public static Color PCP_AXIX_NAME_COLOR = Color.orange;

  /***** White background color scheme */
  static int greyAmt = 170;
  public static Color background = new Color(greyAmt, greyAmt, greyAmt);; //Color.lightGray; //.brighter(); // Color.black;
  public static Color disabled = Color.gray;//Color.lightGray.brighter(); //
  public static Color edgecolor = Color.blue; //.cyan; //new Color(0, 0, 255, 128); //new Color(143, 57, 191); //purple
  public static Color pointcolor = Color.darkGray; //.lightGray;
  public static Color labelcolor = Color.black; //.pink;
  public static Color corepointcolor = Color.green;
  public static Color neutralcolor = Color.darkGray;
  public static Color selection = Color.yellow;

  public static Color PCP_AXIS_COLOR = Color.gray;
  public static Color PCP_AXIX_VALUE_COLOR = Color.black;
  public static Color PCP_AXIX_NAME_COLOR = Color.black;

/*
  private static final Color background = Color.black;
  private static final Color disabled   = Color.darkGray;
  private static final Color edgecolor  = Color.cyan; //new Color(0, 0, 255, 128); //new Color(143, 57, 191); //purple
  private static final Color pointcolor = Color.lightGray;
  private static final Color labelcolor = Color.pink;
  private static final Color corepointcolor = Color.green;
  private static final Color neutralcolor = Color.darkGray;

  public static final Color PCP_AXIS_COLOR = Color.blue;
  public static final Color PCP_AXIX_VALUE_COLOR = Color.cyan;
  public static final Color PCP_AXIX_NAME_COLOR = Color.red;
*/


  public static boolean opposit = false;

  public ColorSetting() {
  }


  public static Color getOpposit(Color c)
  {
    return new Color(255-c.getRed(), 255-c.getGreen() , 255-c.getBlue());
  }

  public static Color getShifted(Color c, int distance)
  {
    int r = ((c.getRed() + distance) <= 255 ? (c.getRed() + distance): (c.getRed() - distance));
    int g = ((c.getGreen() + distance) <= 255 ? (c.getGreen() + distance): (c.getGreen() - distance));
    int b = ((c.getBlue() + distance) <= 255 ? (c.getBlue() + distance): (c.getBlue() - distance));

      Color color = null;
      try {
          r = validColorValue(r);
          g=validColorValue(g);
          b=validColorValue(b) ;
          color = new Color(r, g, b);
      } catch (Exception e) {
          e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      }
      return color;
  }
  public static int validColorValue(int color){
      int v=color;
      if(v<0){
          v=0;
      }
      else if(v>255){
          v=255;
      }
      return v;
  }


  public Color getBackground()
  {
    if (opposit) return getOpposit(background);
    else return  background;
  }

  public Color getDisabled()
  {
    if (opposit) return getOpposit(disabled);
    else return  disabled;
  }

  public  Color getEdgecolor()
  {
    return  edgecolor;
  }

  public  Color getPointcolor()
  {
    if (opposit) return getOpposit(pointcolor);
    else return  pointcolor;
  }
  public  Color getLabelcolor()
  {
    if (opposit) return getOpposit(labelcolor);
    else return  labelcolor;
  }
  public  Color getSelection()
  {
    if (opposit) return getOpposit(selection);
    else return  selection;
  }

  public  Color getCorepointcolor()
  {
    if (opposit) return getOpposit(corepointcolor);
    else return  corepointcolor;
  }
  public static Color getNonCorepointcolor()
  {
    if (!opposit) return getOpposit(corepointcolor);
    else return  corepointcolor;
  }
  public boolean isOpposit() {
    return opposit;
  }
  public Color getPCP_AXIS_COLOR() {
    return PCP_AXIS_COLOR;
  }
  public Color getPCP_AXIX_NAME_COLOR() {
    return PCP_AXIX_NAME_COLOR;
  }
  public Color getPCP_AXIX_VALUE_COLOR() {
    return PCP_AXIX_VALUE_COLOR;
  }
  public void setBackground(Color background) {
    this.background = background;
  }
  public void setCorepointcolor(Color corepointcolor) {
    this.corepointcolor = corepointcolor;
  }
  public void setDisabled(Color disabled) {
    this.disabled = disabled;
  }
  public void setEdgecolor(Color edgecolor) {
    this.edgecolor = edgecolor;
  }
  public void setLabelcolor(Color labelcolor) {
    this.labelcolor = labelcolor;
  }
  public void setNeutralcolor(Color neutralcolor) {
    this.neutralcolor = neutralcolor;
  }
  public void setOpposit(boolean opposit) {
    this.opposit = opposit;
  }
  public void setPCP_AXIS_COLOR(Color PCP_AXIS_COLOR) {
    this.PCP_AXIS_COLOR = PCP_AXIS_COLOR;
  }
  public void setPCP_AXIX_NAME_COLOR(Color PCP_AXIX_NAME_COLOR) {
    this.PCP_AXIX_NAME_COLOR = PCP_AXIX_NAME_COLOR;
  }
  public void setPCP_AXIX_VALUE_COLOR(Color PCP_AXIX_VALUE_COLOR) {
    this.PCP_AXIX_VALUE_COLOR = PCP_AXIX_VALUE_COLOR;
  }
  public void setPointcolor(Color pointcolor) {
    this.pointcolor = pointcolor;
  }
  public void setSelection(Color selection) {
    this.selection = selection;
  }
  public Color getNeutralcolor() {
    return neutralcolor;
  }
}