<!-- The following file is the first file in the process of Actor Documentaion formation.

     This file produces an xml output which consists of all the available kepler concepts

     as given in the file "ontology.owl" -->



<!--

			### Documentation Process ###



   1)  Process ontology.owl to KeplerConcepts.xml  [xsl stylesheet: ConceptFormation.xsl]

   2)  Process KeplerConcepts.xml to ConceptActorOutput.xml [xsl stylesheet: ActorFormation.xsl]

   3)  Process ConceptActorOutput.xml to KeplerDocumentation.html [xsl stylesheet: DocumentationFormation.xsl]



   Using Ant:-

   > ant build.xml



   Using makefile:-

   > make documentation





   File Output contains:- 1) A concept hierarchy structure tree

			  2) A List of all Concept nodes ( Main concepts + their sub concepts)

			  3) 2 file references for getting actor information used in the next step of the process.





-->     		

 



<xsl:stylesheet version="1.0"

xmlns:xsl="http://www.w3.org/1999/XSL/Transform"

xmlns:rdf  = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"

xmlns:rdfs = "http://www.w3.org/2000/01/rdf-schema#"

xmlns:owl  = "http://www.w3.org/2002/07/owl#"

xmlns:ont  = "http://seek.ecoinformatics.org/ontology#"

xmlns      = "http://seek.ecoinformatics.org/ontology#"

xml:base   = "http://seek.ecoinformatics.org/ontology#">





<xsl:template match="rdf:RDF">



	<keplerConcepts>

	

	   <!-- Making a tree to represent the concept hierarchy structure -->

	    

	   <conceptTree>

		

		<xsl:for-each select="owl:Class">

		

			<xsl:variable name="CurrentMainConcept" select="./@rdf:ID"/>

				<ParentConcept>

					<xsl:value-of select="$CurrentMainConcept"/>

		

	

					<!-- Get all the sub concepts belonging to the current main concept-->

					<xsl:variable name="SubConcepts" select="//owl:Class"/>

					<xsl:for-each select="$SubConcepts">

						<xsl:variable name="thisConcept" select="."/>

				

							<xsl:if test="substring-after($thisConcept/rdfs:subClassOf/@rdf:resource,'#') = $CurrentMainConcept">

								<ChildConcept>

									<xsl:value-of select= "$thisConcept/@rdf:ID"/>

								</ChildConcept>

							</xsl:if>

					</xsl:for-each>

				</ParentConcept>	

		</xsl:for-each>



           </conceptTree>

	   <!-- All the Kepler Concepts in ontology.owl -->

	   <xsl:apply-templates select="owl:Class"/>



           <!-- Input File for Actor's LSID and associated Concepts -->

	   <ActorFiles name="../src/annotations.owl">

	   </ActorFiles>



           <!-- Input File for Actor's entity,name and LSID information -->

	   <ActorFiles name="../src/basicKeplerActorLibrary.xml">

	   </ActorFiles>



	</keplerConcepts>

</xsl:template>



<!-- ================================================================================= -->

<!-- Template to get all the possible concepts in Kepler -->



<xsl:template match="rdf:RDF/owl:Class">



<conceptName>

	<xsl:value-of select="@rdf:ID"/>

</conceptName>





<conceptNameMain>

	<xsl:value-of select="rdfs:subClassOf/@rdf:resource"/>

</conceptNameMain>



</xsl:template>







<xsl:template match="*" priority="-1.0">

<TEST.MISSED/>

</xsl:template>





</xsl:stylesheet>