/**
 *    '$RCSfile: QuickSearchCancelAction.java,v $'
 *
 *     '$Author: brooke $'
 *       '$Date: 2005/11/11 04:42:51 $'
 *   '$Revision: 1.3 $'
 *
 *  For Details: http://kepler.ecoinformatics.org
 *
 * Copyright (c) 2003 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY
 * OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */
package org.ecoinformatics.seek.ecogrid;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

/**
 * @author tao
 *
 * This class will cancel a search action by killing the thread. This action
 * will be added to the gui for the cancel buttion in data search panel inkepler
 */
public class QuickSearchCancelAction extends AbstractAction
{
    private QuickSearchAction search = null;

    /**
     * Constructor
     * @param search  the action will be stopped
     */
    public QuickSearchCancelAction(QuickSearchAction search, String name)
    {
        super(name);
        this.search = search;
    }

    /**
     * Implement the abstract method to stop the search action
     */
    public void actionPerformed(ActionEvent e)
    {
        if (search != null)
        {
            search.stop();
            //dataPanel.complete(null);
        }
    }
}
