/* Web service harvester....
 Copyright (c) 2000-2003 The Regents of the University of California.
 All rights reserved.
 Permission is hereby granted, without written agreement and without
 license or royalty fees, to use, copy, modify, and distribute this
 software and its documentation for any purpose, provided that the above
 copyright notice and the following two paragraphs appear in all copies
 of this software.
 IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
 THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.
 THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.
                                        PT_COPYRIGHT_VERSION_2
                                        COPYRIGHTENDKEY
 */

package org.sdm.spa;

import org.ecoinformatics.seek.sms.AnnotationEngine;
import org.ecoinformatics.seek.sms.KeplerLocalLSIDService;

import ptolemy.actor.TypedAtomicActor;
import ptolemy.kernel.CompositeEntity;
import ptolemy.kernel.util.IllegalActionException;
import ptolemy.kernel.util.NameDuplicationException;
import ptolemy.moml.EntityLibrary;

//////////////////////////////////////////////////////////////////////////
//// DynamicActorRegistry
/** This is to test the actor registry parts implemented by Shawn.

    @author Ilkay Altintas
    @version $Id: DynamicActorRegistryTest.java,v 1.7 2005/11/01 20:39:14 ruland Exp $
 */

public class DynamicActorRegistryTest extends TypedAtomicActor {
    
    public DynamicActorRegistryTest(CompositeEntity container, String name) throws
	NameDuplicationException, IllegalActionException {

	super(container, name);

	_attachText("_iconDescription",
		    "<svg>\n"
		    + "<rect x=\"0\" y=\"0\" "
		    + "width=\"80\" height=\"40\" "
		    + "style=\"fill:white\"/>\n"
		    + "</svg>\n");
	
    } // end of constructor

    ///////////////////////////////////////////////////////////////////
    ////                        public methods                     ////

    /** Use SMS components to register a web service stub actor.
     *
     *  @exception IllegalActionException If there is no director.
     */
      public void fire() throws IllegalActionException {
	  super.fire();

	  KeplerLocalLSIDService service = KeplerLocalLSIDService.instance();
	  AnnotationEngine engine = AnnotationEngine.instance();

	  String namespace = "Blast_searchParam";
	  String id = "1";
	  try {
	      String lsid = service.createLSID(namespace, id);
	      WebServiceStub wss = new WebServiceStub(new EntityLibrary(), namespace);
	      service.assignLSID(lsid, wss);
	      service.commitChanges();
	      engine.addActorAnnotation(lsid, "Actor");	      
	  } catch(Exception e) {
	      e.printStackTrace();
	  }

      } // end of fire


    public boolean postfire() {
	return false;
    }
}